(function(){
  'use strict';

  $( document ).ready(function(){
    if($('#copyrightButton').length){
      $('#copyrightButton').click(handleCopyright);
    }
    if($('#recreateDoc').length){
      $('#recreateDoc').submit(request);
    }
    if($('.ub-action-acl').length){
      var options = {
        autoOpen : false,
        width : 600,
        closeText : translate('FU.js.close'),
        buttons : [{
          text : translate('FU.js.close'),
          click : function() {
            $( this ).dialog('close');
          }
        },{
          text : translate('swf.editor.acl.set'),
          click : function(){
            if( !$('#acl-dialog input[name="rule"]:checked').val() ){
              alert('Please select one rule');
              return;
            }
            request({
              data : $('#acl-dialog form').serialize(),
              url : webApplicationBaseURL + 'servlets/FUReadPermServlet'
            });
            $( this ).dialog('close');
          }
        }]
      };
      $('#acl-dialog').dialog(options);
      $('.ub-action-acl').submit(function(event){
        event.preventDefault();
        var $this = $(this);
        var id = $this.find('input[name="objid"]').val();
        $('#acl-dialog input[name="id"]').val(id);

        var parent_id = $this.find('input[name="parent_id"]').val();
        if(parent_id){
          $('#acl-dialog input[name="parent_id"]').val(parent_id);
        } else {
          $('#acl-dialog input[name="parent_id"]').val(parent_id);
        }

        $('#acl-dialog input[name="objid"]').val(id);
        $('#acl-dialog input[name="redir"]').val(webApplicationBaseURL + 'receive/' + id );
        $('#acl-dialog').dialog('open');
      });
      

    }
  });



  var handleCopyright = function(e) {
    e.preventDefault();

    var $table = $(this).parent().parent().parent();
    var select = $table.find('table.editorRepeater select.editorList');
    var issnCounter = 0;

    for(var i = 0; i < select.length; i++){
      if($(select[i]).find('option:selected').val() === 'issn'){
        var issn = $(select[i]).parent().parent().find('input.editorTextfield').val();
        requestCopyright(issn);
        issnCounter++;
      }
    }
    if(issnCounter === 0){
      alert('Es ist keine ISSN angegeben, die überprüft werden kann.\n' +
          'Stellen Sie sicher, dass die Auswahlliste rechts auf "ISSN" gesetzt ist');
    }
  };

  var requestCopyright = function(issn){
    var url = webApplicationBaseURL + 'servlets/FUWebserviceProxy?service=sherpa';
    url += '&issn=' + encodeURIComponent(issn);
    url += '&qtype=all';
    request({url: url, 
      success: showCopyright,
      headers: {
        Accept: 'application/xml, text/xml, application/json; charset=utf-8',
        'Content-Type' : 'application/xml, text/xml, application/json; charset=utf-8'
      }
    });
  };

  var showCopyright = function( data ){
    if(typeof data === 'object'){
      showDialog(data);
      return;
    }
    var $data = $($.parseXML( data ));
    var $dialog = $('#sherpa-dialog');
    var $outerDiv = $( document.createElement('div') );
    var $parameter = $( document.createElement('h3') );
    $parameter.text('Parameter: ');
    var $dataParams = $data.find('parameters parameter[source="specified"]');
    for(var i=0; i < $dataParams.length; i++){
      var name = $($($dataParams[i]).find('parametername')).text();
      var value = $($($dataParams[i]).find('parametervalue')).text();
      $parameter.append( '(' + name + ' : ' + value + ') ');
    }
    $outerDiv.append($parameter);
    var $hits = $( document.createElement('p') );
    $hits.css('font-weight', 'bold');
    var hits = $($data.find('numhits')).text();
    if(hits === undefined || hits === ''){
      hits = '0';
    }
    $hits.text('Treffer: ' + hits);
    $outerDiv.append($hits);
    var title = $($data.find('journal jtitle')).text();
    if(title !== undefined && title !== ''){
      var $journal = $( document.createElement('p') );
      $journal.text('Titel: ' + $($data.find('journal jtitle')).text());
      console.log($journal.text()); 
      $outerDiv.append($journal);
    }
    if(hits === '0'){
      var errorMessage = $($data.find('message')).text();
      if(errorMessage !== undefined && errorMessage !== ''){
        var $errorMessage = $( document.createElement('p') ).text('Fehlermeldung: ');
        $errorMessage.append(errorMessage);
        $outerDiv.append($errorMessage);
        
      }
    }

    var $publisherHeader = $( document.createElement('h3') ).text('Verlag');
    var pub = $data.find('publishers publisher');
    if(pub !== undefined){
      var $list = printXML(pub, ['conditions', 'copyrightlinks']);
      $outerDiv.append($list);
    }

    var $conditionDiv = $( document.createElement('div') ).addClass('ub-dialogSection');
    var $conditionHeader = $( document.createElement('h3') ).text('Bedingungen');
    $conditionDiv.append($conditionHeader);
    
    var $conditionList = $( document.createElement('ul') );
    var conditionList = $data.find('conditions condition');
    for(var i = 0; i < conditionList.length; i++){
      var $condition = $( document.createElement('li') );
      $condition.text($(conditionList[i]).text());
      $conditionList.append($condition);
    }
    $conditionDiv.append($conditionList);
    $outerDiv.append($conditionDiv);

    var $copyrightDiv = $( document.createElement('div') ).addClass('ub-dialogSection');

    var $copyrightHeader = $( document.createElement('h3') ).text('Copyrights');
    $copyrightDiv.append($copyrightHeader);
    var $copyrightList = $( document.createElement('ul') );
    var copyrightList = $data.find('copyrightlinks copyrightlink');
    for(var i = 0; i < copyrightList.length; i++){
      var $cpElement = $( document.createElement('li') );
      var $cpLink = $( document.createElement('a') ).attr('target', '_blank');
      $cpLink.text($($(copyrightList[i]).find('copyrightlinktext')).text());
      $cpLink.attr('href', $($(copyrightList[i]).find('copyrightlinkurl')).text());
      $cpElement.append($cpLink);
      $copyrightList.append($cpElement);
    }
    $copyrightDiv.append($copyrightList);
    $outerDiv.append($copyrightDiv);
    var dialogOptions = {
      autoOpen: false,
      width: 600,
      closeText: translate('FU.js.close'),
      buttons: [{text: translate('FU.js.close'), click: function() {$ (this).dialog('close')}}]
    };

    var open = $dialog.dialog(dialogOptions).dialog('isOpen');
    if(!open){
      $dialog.empty();
    }


    $dialog.append($outerDiv);
    if(!open){
      $dialog.dialog('open');
    }

  };

  Element.prototype.hasChildNodes = function(){
    for(var i = 0; i < this.childNodes.length; i++){
      if(this.childNodes[i] instanceof Element){
        return true;
      }
    }
    return false;
  }

  var printXML = function(data, filter){
    var $list = $( document.createElement('ul') );
    if(data.childnodes === undefined){
      return;
    }
    for(var i = 0; i  < data.childNodes.length; i++){
      var child = data.childNodes[i];
      if(filter.indexOf(child.nodeName) === -1){
        if(child instanceof Element){
          if(child.hasChildNodes()){
            var $firstLine = $( document.createElement('li') );
            var $secondLine = $( document.createElement('li') );
            $firstLine.text(child.nodeName);
            $secondLine.append(printXML(child, filter));
            $list.append($firstLine);
            $list.append($secondLine);
          } else if($(child).text() !== '') {
            console.log($(child).text());
            var $line = $( document.createElement('li') );
            $line.text(child.nodeName + " : " + $(child).text());
            $list.append($line);
          }
        }
      }

    }
    return $list;
  };


})()
