var messages;

var localeURL = webApplicationBaseURL + 
'servlets/MCRLocaleServlet/' +
currentLang + '/';

var loadMessages = function(prefix){
  var url = localeURL + prefix + '.*';

  $.ajax({url: url, async: false}).done(function(data){
    if(messages === undefined){
      messages = data;
    } else {
      for(var i in data){
        messages[i] = data[i];
      }
    }

  }).fail(function(){console.log('An error occurred when requesting url ' 
      + url)});
}

var translate = function(){
  var key = arguments[0];
  if(messages !== undefined){
    if(messages[key] !== undefined){
      return messages[key];
    }
  }
  var prefix;
  if(arguments.length === 1){
    prefix = key.substring(0, key.lastIndexOf('.'));
  } else {
    prefix = arguments[1];
  }
  loadMessages(prefix);
  if(messages === undefined){
    return '???' + key + '???';
  } 

  var m = messages[key];
  if(m === undefined){
    return '???' + key + '???';
  }
  return m;

};


var showDialog = function(data){
  var $dialog = $( '#dialog' );
  var dialogClass = 'ub-dialog-info';
  if(data.status === 0 || data.status === 'info'){
    $dialog.attr('title', 'Info');
  } else if (data.status === 2 || data.status === 'error'){
    $dialog.attr('title', 'Warning');
    dialogClass = 'ub-dialog-warning';
  } else {
    $dialog.attr('title', 'Error');
    dialogClas = 'ub-dialog-warning';
  }
  
  $dialog.text(data.message);

  var buttons = [{text: translate('FU.js.close'),
    click: function(){
      $( this ).dialog('close');
    }}];
  if(data.forwardURL !== undefined && data.forwardURL !== ''){
    buttons.push({
      text: data.forwardLabel,
      click: function(){
        $( this ).dialog('close');
        location.href = data.forwardURL;
      }
    });
  }

  
  var dialogOptions = {
    autoOpen: false,
    position: { my: 'top', at: 'top+150' },
    width: 600,
    closeText: translate('FU.js.close'),
    buttons: buttons,
    dialogClass: dialogClass
  };
  $dialog.dialog(dialogOptions);
  $dialog.dialog('open');
};


var request = function(arg){
  if(arg.preventDefault){
    arg.preventDefault();
  }
  $('#loading').css('display', 'block');
  var options = {
    timeout : 15000,
    complete : function(){
      $('#loading').css('display', 'none');
    },
    success : showDialog,
    error : function(jqXHR, textStatus, errorThrown){
      if(textStatus === 'timeout'){
        showDialog({status: 'error', message: translate('FU.js.timeout')});
      } else {
        showDialog({status: 'error', message: translate('FU.js.requestFailed')});
      }
    },
    headers : {
      Accept : 'application/json; charset=utf-8',
      'Content-Type' : 'application/json; charset=utf-8'
    }
  };
  if (typeof arg === 'string'){
    options.url = arg;
  } else if(arg.target){

    $form = $( this );
    options.url = $form.attr('action');
    options.data = $form.serialize();
  } else {
    options = $.extend(options, arg);
  }
  console.log(options);
  $.ajax(options);
  
};
